Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ConcurrentHashMultiset<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          com.google.common.collect.ConcurrentHashMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Serializable, Iterable<E>, Collection<E>

    public final class ConcurrentHashMultiset<E>

extends AbstractCollection<E>
implements Serializable

A multiset that supports concurrent modifications and that provides atomic versions of most `Multiset` operations (exceptions where noted). Null elements are not supported.

Author:
  Cliff L. Biffle
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Method Summary
`boolean` | `add(E element)` Ensures that this collection contains the specified element (optional operation).
`int` | `add(E element, int occurrences)` Adds a number of occurrences of the specified element to this multiset.
`boolean` | `addAll(Collection<? extends E> elementsToAdd)` Adds all of the elements in the specified collection to this collection (optional operation).
`void` | `clear()` Removes all of the elements from this collection (optional operation).
`boolean` | `contains(Object element)` Returns `true` if this collection contains the specified element.
`boolean` | `containsAll(Collection<?> elements)` Returns `true` if this collection contains all of the elements in the specified collection.
`int` | `count(Object element)` Returns the number of occurrences of `element` in this multiset.
`static
`<E> ConcurrentHashMultiset<E>`
` | `create()` Creates a new, empty `ConcurrentHashMultiset` using the default initial capacity, load factor, and concurrency settings.
`static
`<E> ConcurrentHashMultiset<E>`
` | `create(Iterable<? extends E> elements)` Creates a new `ConcurrentHashMultiset` containing the specified elements, using the default initial capacity, load factor, and concurrency settings.
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`int` | `hashCode()` Returns a hash code value for the object.
`boolean` | `isEmpty()` Returns `true` if this collection contains no elements.
`Iterator<E>` | `iterator()` Returns an iterator over the elements contained in this collection.
`boolean` | `remove(Object element)` Removes a single instance of the specified element from this collection, if it is present (optional operation).
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`boolean` | `removeAll(Collection<?> elementsToRemove)` Removes all of this collection's elements that are also contained in the specified collection (optional operation).
`boolean` | `removeExactly(Object element, int occurrences)` Removes exactly the specified number of occurrences of `element`, or makes no change if this is not possible.
`boolean` | `retainAll(Collection<?> elementsToRetain)` Retains only the elements in this collection that are contained in the specified collection (optional operation).
`int` | `setCount(E element, int count)` Adds or removes occurrences of `element` such that the `count(java.lang.Object)` of the element becomes `count`.
`boolean` | `setCount(E element, int oldCount, int newCount)` Sets the number of occurrences of `element` to `newCount`, but only if the count is currently `oldCount`.
`int` | `size()` Returns the number of elements in this collection.
`Object[]` | `toArray()` Returns an array containing all of the elements in this collection.
`
`<T> T[]`
` | `toArray(T[] array)` Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.
`String` | `toString()` Returns a string representation of this collection.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### create

    public static <E> ConcurrentHashMultiset<E> create()

  Creates a new, empty `ConcurrentHashMultiset` using the default initial capacity, load factor, and concurrency settings.

### create

    public static <E> ConcurrentHashMultiset<E> create(Iterable<? extends E> elements)

  Creates a new `ConcurrentHashMultiset` containing the specified elements, using the default initial capacity, load factor, and concurrency settings.

  Parameters:
    `elements` - the elements that the multiset should contain

### count

    public int count(@Nullable
                     Object element)

  Returns the number of occurrences of `element` in this multiset.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to look for
  Returns:
    the nonnegative number of occurrences of the element

### size

    public int size()

  Returns the number of elements in this collection. If this collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  If the data in the multiset is modified by any other threads during this method, it is undefined which (if any) of these modifications will be reflected in the result.

  Specified by:
    `size` in interface `Collection<E>`
  Returns:
    the number of elements in this collection

### toArray

    public Object[] toArray()

  Description copied from class: `java.util.AbstractCollection`
  Returns an array containing all of the elements in this collection. If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  The returned array will be "safe" in that no references to it are maintained by this collection. (In other words, this method must allocate a new array even if this collection is backed by an array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and collection-based APIs.

  This implementation returns an array containing all the elements returned by this collection's iterator, in the same order, stored in consecutive elements of the array, starting with index `0`. The length of the returned array is equal to the number of elements returned by the iterator, even if the size of this collection changes during iteration, as might happen if the collection permits concurrent modification during iteration. The `size` method is called only as an optimization hint; the correct result is returned even if the iterator returns a different number of elements.

  This method is equivalent to:

       List<E> list = new ArrayList<E>(size());
       for (E e : this)
           list.add(e);
       return list.toArray();

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Returns:
    an array containing all of the elements in this collection

### toArray

    public <T> T[] toArray(T[] array)

  Description copied from class: `java.util.AbstractCollection`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array. If the collection fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this collection.

  If this collection fits in the specified array with room to spare (i.e., the array has more elements than this collection), the element in the array immediately following the end of the collection is set to `null`. (This is useful in determining the length of this collection only if the caller knows that this collection does not contain any `null` elements.)

  If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  Like the `Collection.toArray()` method, this method acts as bridge between array-based and collection-based APIs. Further, this method allows precise control over the runtime type of the output array, and may, under certain circumstances, be used to save allocation costs.

  Suppose `x` is a collection known to contain only strings. The following code can be used to dump the collection into a newly allocated array of `String`:

           String[] y = x.toArray(new String[0]);

  Note that `toArray(new Object[0])` is identical in function to `toArray()`.

  This implementation returns an array containing all the elements returned by this collection's iterator in the same order, stored in consecutive elements of the array, starting with index `0`. If the number of elements returned by the iterator is too large to fit into the specified array, then the elements are returned in a newly allocated array with length equal to the number of elements returned by the iterator, even if the size of this collection changes during iteration, as might happen if the collection permits concurrent modification during iteration. The `size` method is called only as an optimization hint; the correct result is returned even if the iterator returns a different number of elements.

  This method is equivalent to:

       List<E> list = new ArrayList<E>(size());
       for (E e : this)
           list.add(e);
       return list.toArray(a);

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Parameters:
    `array` - the array into which the elements of this collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing all of the elements in this collection

### add

    public int add(E element,
                   int occurrences)

  Adds a number of occurrences of the specified element to this multiset.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add
    `occurrences` - the number of occurrences to add
  Returns:
    the previous count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative, or if the resulting amount would exceed `Integer.MAX_VALUE`

### remove

    public int remove(@Nullable
                      Object element,
                      int occurrences)

  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element whose occurrences should be removed
    `occurrences` - the number of occurrences of the element to remove
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative

### removeExactly

    public boolean removeExactly(@Nullable
                                 Object element,
                                 int occurrences)

  Removes exactly the specified number of occurrences of `element`, or makes no change if this is not possible.

  This method, in contrast to `remove(Object, int)`, has no effect when the element count is smaller than `occurrences`.

  Parameters:
    `element` - the element to remove
    `occurrences` - the number of occurrences of `element` to remove
  Returns:
    `true` if the removal was possible (including if `occurrences` is zero)

### setCount

    public int setCount(E element,
                        int count)

  Adds or removes occurrences of `element` such that the `count(java.lang.Object)` of the element becomes `count`.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of `element` in the multiset before this call
  Throws:
    `IllegalArgumentException` - if `count` is negative

### setCount

    public boolean setCount(E element,
                            int oldCount,
                            int newCount)

  Sets the number of occurrences of `element` to `newCount`, but only if the count is currently `oldCount`. If `element` does not appear in the multiset exactly `oldCount` times, no changes will be made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the change was successful. This usually indicates that the multiset has been modified, but not always: in the case that `oldCount == newCount`, the method will return `true` if the condition was met.
  Throws:
    `IllegalArgumentException` - if `oldCount` or `newCount` is negative

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Description copied from interface: `Multiset`
  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### isEmpty

    public boolean isEmpty()

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains no elements.

  This implementation returns `size() == 0`.

  Specified by:
    `isEmpty` in interface `Collection<E>`
  Overrides:
    `isEmpty` in class `AbstractCollection<E>`
  Returns:
    `true` if this collection contains no elements

### contains

    public boolean contains(@Nullable
                            Object element)

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains the specified element. More formally, returns `true` if and only if this collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  This implementation iterates over the elements in the collection, checking each element in turn for equality with the specified element.

  Specified by:
    `contains` in interface `Multiset<E>`
  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `element` - element whose presence in this collection is to be tested
  Returns:
    `true` if this collection contains the specified element

### iterator

    public Iterator<E> iterator()

  Description copied from class: `java.util.AbstractCollection`
  Returns an iterator over the elements contained in this collection.

  Specified by:
    `iterator` in interface `Multiset<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in class `AbstractCollection<E>`
  Returns:
    an iterator over the elements contained in this collection

### add

    public boolean add(@Nullable
                       E element)

  Description copied from class: `java.util.AbstractCollection`
  Ensures that this collection contains the specified element (optional operation). Returns `true` if this collection changed as a result of the call. (Returns `false` if this collection does not permit duplicates and already contains the specified element.)

  Collections that support this operation may place limitations on what elements may be added to this collection. In particular, some collections will refuse to add `null` elements, and others will impose restrictions on the type of elements that may be added. Collection classes should clearly specify in their documentation any restrictions on what elements may be added.

  If a collection refuses to add a particular element for any reason other than that it already contains the element, it must throw an exception (rather than returning `false`). This preserves the invariant that a collection always contains the specified element after this call returns.

  This implementation always throws an `UnsupportedOperationException`.

  Specified by:
    `add` in interface `Multiset<E>`
  Specified by:
    `add` in interface `Collection<E>`
  Overrides:
    `add` in class `AbstractCollection<E>`
  Parameters:
    `element` - element whose presence in this collection is to be ensured
  Returns:
    `true` if this collection changed as a result of the call

### remove

    public boolean remove(Object element)

  Description copied from class: `java.util.AbstractCollection`
  Removes a single instance of the specified element from this collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if this collection contains one or more such elements. Returns `true` if this collection contained the specified element (or equivalently, if this collection changed as a result of the call).

  This implementation iterates over the collection looking for the specified element. If it finds the element, it removes the element from the collection using the iterator's remove method.

  Note that this implementation throws an `UnsupportedOperationException` if the iterator returned by this collection's iterator method does not implement the `remove` method and this collection contains the specified object.

  Specified by:
    `remove` in interface `Multiset<E>`
  Specified by:
    `remove` in interface `Collection<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `element` - element to be removed from this collection, if present
  Returns:
    `true` if an element was removed as a result of this call

### containsAll

    public boolean containsAll(Collection<?> elements)

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains all of the elements in the specified collection.

  This implementation iterates over the specified collection, checking each element returned by the iterator in turn to see if it's contained in this collection. If all elements are so contained `true` is returned, otherwise `false`.

  Specified by:
    `containsAll` in interface `Multiset<E>`
  Specified by:
    `containsAll` in interface `Collection<E>`
  Overrides:
    `containsAll` in class `AbstractCollection<E>`
  Parameters:
    `elements` - collection to be checked for containment in this collection
  Returns:
    `true` if this collection contains all of the elements in the specified collection
  See Also:
    `AbstractCollection.contains(Object)`

### addAll

    public boolean addAll(Collection<? extends E> elementsToAdd)

  Description copied from class: `java.util.AbstractCollection`
  Adds all of the elements in the specified collection to this collection (optional operation). The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the specified collection is this collection, and this collection is nonempty.)

  This implementation iterates over the specified collection, and adds each object returned by the iterator to this collection, in turn.

  Note that this implementation will throw an `UnsupportedOperationException` unless `add` is overridden (assuming the specified collection is non-empty).

  Specified by:
    `addAll` in interface `Collection<E>`
  Overrides:
    `addAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToAdd` - collection containing elements to be added to this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.add(Object)`

### removeAll

    public boolean removeAll(Collection<?> elementsToRemove)

  Description copied from class: `java.util.AbstractCollection`
  Removes all of this collection's elements that are also contained in the specified collection (optional operation). After this call returns, this collection will contain no elements in common with the specified collection.

  This implementation iterates over this collection, checking each element returned by the iterator in turn to see if it's contained in the specified collection. If it's so contained, it's removed from this collection with the iterator's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method and this collection contains one or more elements in common with the specified collection.

  Specified by:
    `removeAll` in interface `Multiset<E>`
  Specified by:
    `removeAll` in interface `Collection<E>`
  Overrides:
    `removeAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToRemove` - collection containing elements to be removed from this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

### retainAll

    public boolean retainAll(Collection<?> elementsToRetain)

  Description copied from class: `java.util.AbstractCollection`
  Retains only the elements in this collection that are contained in the specified collection (optional operation). In other words, removes from this collection all of its elements that are not contained in the specified collection.

  This implementation iterates over this collection, checking each element returned by the iterator in turn to see if it's contained in the specified collection. If it's not so contained, it's removed from this collection with the iterator's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method and this collection contains one or more elements not present in the specified collection.

  Specified by:
    `retainAll` in interface `Multiset<E>`
  Specified by:
    `retainAll` in interface `Collection<E>`
  Overrides:
    `retainAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToRetain` - collection containing elements to be retained in this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

### clear

    public void clear()

  Description copied from class: `java.util.AbstractCollection`
  Removes all of the elements from this collection (optional operation). The collection will be empty after this method returns.

  This implementation iterates over this collection, removing each element using the `Iterator.remove` operation. Most implementations will probably choose to override this method for efficiency.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by this collection's `iterator` method does not implement the `remove` method and this collection is non-empty.

  Specified by:
    `clear` in interface `Collection<E>`
  Overrides:
    `clear` in class `AbstractCollection<E>`

### elementSet

    public Set<E> elementSet()

  Description copied from interface: `Multiset`
  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### equals

    public boolean equals(@Nullable
                          Object object)

  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  This implementation returns `true` if `other` is a multiset of the same size and if, for each element, the two multisets have the same count.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  This implementation returns the hash code of `Multiset.entrySet()`.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string representation of this collection. The string representation consists of a list of the collection's elements in the order they are returned by its iterator, enclosed in square brackets (`"[]"`). Adjacent elements are separated by the characters `", "` (comma and space). Elements are converted to strings as by `String.valueOf(Object)`.

  This implementation returns the result of invoking `toString` on `Multiset.entrySet()`.

  Specified by:
    `toString` in interface `Multiset<E>`
  Overrides:
    `toString` in class `AbstractCollection<E>`
  Returns:
    a string representation of this collection

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD